<?php
/**
 * Banner
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\CmsClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi Cms.
 *
 * Управление контентом
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\CmsClient\Dto;

use \ArrayAccess;
use \Ensi\CmsClient\ObjectSerializer;

/**
 * Banner Class Doc Comment
 *
 * @category Class
 * @package  Ensi\CmsClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class Banner implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'Banner';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'desktop_image' => '\Ensi\CmsClient\Dto\File',
        'tablet_image' => '\Ensi\CmsClient\Dto\File',
        'mobile_image' => '\Ensi\CmsClient\Dto\File',
        'button_id' => 'int',
        'name' => 'string',
        'active' => 'bool',
        'url' => 'string',
        'type_id' => 'int',
        'button' => '\Ensi\CmsClient\Dto\BannerButton',
        'type' => '\Ensi\CmsClient\Dto\BannerType'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'id' => null,
        'desktop_image' => null,
        'tablet_image' => null,
        'mobile_image' => null,
        'button_id' => null,
        'name' => null,
        'active' => null,
        'url' => null,
        'type_id' => null,
        'button' => null,
        'type' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'id' => false,
        'desktop_image' => false,
        'tablet_image' => false,
        'mobile_image' => false,
        'button_id' => true,
        'name' => false,
        'active' => false,
        'url' => false,
        'type_id' => false,
        'button' => false,
        'type' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'desktop_image' => 'desktop_image',
        'tablet_image' => 'tablet_image',
        'mobile_image' => 'mobile_image',
        'button_id' => 'button_id',
        'name' => 'name',
        'active' => 'active',
        'url' => 'url',
        'type_id' => 'type_id',
        'button' => 'button',
        'type' => 'type'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'desktop_image' => 'setDesktopImage',
        'tablet_image' => 'setTabletImage',
        'mobile_image' => 'setMobileImage',
        'button_id' => 'setButtonId',
        'name' => 'setName',
        'active' => 'setActive',
        'url' => 'setUrl',
        'type_id' => 'setTypeId',
        'button' => 'setButton',
        'type' => 'setType'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'desktop_image' => 'getDesktopImage',
        'tablet_image' => 'getTabletImage',
        'mobile_image' => 'getMobileImage',
        'button_id' => 'getButtonId',
        'name' => 'getName',
        'active' => 'getActive',
        'url' => 'getUrl',
        'type_id' => 'getTypeId',
        'button' => 'getButton',
        'type' => 'getType'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('id', $data, null);
        $this->setIfExists('desktop_image', $data, null);
        $this->setIfExists('tablet_image', $data, null);
        $this->setIfExists('mobile_image', $data, null);
        $this->setIfExists('button_id', $data, null);
        $this->setIfExists('name', $data, null);
        $this->setIfExists('active', $data, null);
        $this->setIfExists('url', $data, null);
        $this->setIfExists('type_id', $data, null);
        $this->setIfExists('button', $data, null);
        $this->setIfExists('type', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id Идентификатор
     *
     * @return $this
     */
    public function setId($id)
    {


        /*if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }*/
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets desktop_image
     *
     * @return \Ensi\CmsClient\Dto\File|null
     */
    public function getDesktopImage()
    {
        return $this->container['desktop_image'];
    }

    /**
     * Sets desktop_image
     *
     * @param \Ensi\CmsClient\Dto\File|null $desktop_image desktop_image
     *
     * @return $this
     */
    public function setDesktopImage($desktop_image)
    {


        /*if (is_null($desktop_image)) {
            throw new \InvalidArgumentException('non-nullable desktop_image cannot be null');
        }*/
        $this->container['desktop_image'] = $desktop_image;

        return $this;
    }

    /**
     * Gets tablet_image
     *
     * @return \Ensi\CmsClient\Dto\File|null
     */
    public function getTabletImage()
    {
        return $this->container['tablet_image'];
    }

    /**
     * Sets tablet_image
     *
     * @param \Ensi\CmsClient\Dto\File|null $tablet_image tablet_image
     *
     * @return $this
     */
    public function setTabletImage($tablet_image)
    {


        /*if (is_null($tablet_image)) {
            throw new \InvalidArgumentException('non-nullable tablet_image cannot be null');
        }*/
        $this->container['tablet_image'] = $tablet_image;

        return $this;
    }

    /**
     * Gets mobile_image
     *
     * @return \Ensi\CmsClient\Dto\File|null
     */
    public function getMobileImage()
    {
        return $this->container['mobile_image'];
    }

    /**
     * Sets mobile_image
     *
     * @param \Ensi\CmsClient\Dto\File|null $mobile_image mobile_image
     *
     * @return $this
     */
    public function setMobileImage($mobile_image)
    {


        /*if (is_null($mobile_image)) {
            throw new \InvalidArgumentException('non-nullable mobile_image cannot be null');
        }*/
        $this->container['mobile_image'] = $mobile_image;

        return $this;
    }

    /**
     * Gets button_id
     *
     * @return int|null
     */
    public function getButtonId()
    {
        return $this->container['button_id'];
    }

    /**
     * Sets button_id
     *
     * @param int|null $button_id Идентификатор кнопки
     *
     * @return $this
     */
    public function setButtonId($button_id)
    {

        if (is_null($button_id)) {
            array_push($this->openAPINullablesSetToNull, 'button_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('button_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['button_id'] = $button_id;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name Название
     *
     * @return $this
     */
    public function setName($name)
    {


        /*if (is_null($name)) {
            throw new \InvalidArgumentException('non-nullable name cannot be null');
        }*/
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets active
     *
     * @return bool|null
     */
    public function getActive()
    {
        return $this->container['active'];
    }

    /**
     * Sets active
     *
     * @param bool|null $active Активность
     *
     * @return $this
     */
    public function setActive($active)
    {


        /*if (is_null($active)) {
            throw new \InvalidArgumentException('non-nullable active cannot be null');
        }*/
        $this->container['active'] = $active;

        return $this;
    }

    /**
     * Gets url
     *
     * @return string|null
     */
    public function getUrl()
    {
        return $this->container['url'];
    }

    /**
     * Sets url
     *
     * @param string|null $url Ссылка
     *
     * @return $this
     */
    public function setUrl($url)
    {


        /*if (is_null($url)) {
            throw new \InvalidArgumentException('non-nullable url cannot be null');
        }*/
        $this->container['url'] = $url;

        return $this;
    }

    /**
     * Gets type_id
     *
     * @return int|null
     */
    public function getTypeId()
    {
        return $this->container['type_id'];
    }

    /**
     * Sets type_id
     *
     * @param int|null $type_id Идентификатор типа
     *
     * @return $this
     */
    public function setTypeId($type_id)
    {


        /*if (is_null($type_id)) {
            throw new \InvalidArgumentException('non-nullable type_id cannot be null');
        }*/
        $this->container['type_id'] = $type_id;

        return $this;
    }

    /**
     * Gets button
     *
     * @return \Ensi\CmsClient\Dto\BannerButton|null
     */
    public function getButton()
    {
        return $this->container['button'];
    }

    /**
     * Sets button
     *
     * @param \Ensi\CmsClient\Dto\BannerButton|null $button button
     *
     * @return $this
     */
    public function setButton($button)
    {


        /*if (is_null($button)) {
            throw new \InvalidArgumentException('non-nullable button cannot be null');
        }*/
        $this->container['button'] = $button;

        return $this;
    }

    /**
     * Gets type
     *
     * @return \Ensi\CmsClient\Dto\BannerType|null
     */
    public function getType()
    {
        return $this->container['type'];
    }

    /**
     * Sets type
     *
     * @param \Ensi\CmsClient\Dto\BannerType|null $type type
     *
     * @return $this
     */
    public function setType($type)
    {


        /*if (is_null($type)) {
            throw new \InvalidArgumentException('non-nullable type cannot be null');
        }*/
        $this->container['type'] = $type;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


